// Frustum.cpp: implementation of the Frustum class.
//
//////////////////////////////////////////////////////////////////////

#include "Frustum.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Frustum::Frustum()
{

}

Frustum::~Frustum()
{

}

void Frustum :: Extrait (bool extraire_mat)
{
   if (extraire_mat == true)
   {
	glGetFloatv( GL_MODELVIEW_MATRIX, modl );   /* Rcupere la matrice de modelisation */
	glGetFloatv( GL_PROJECTION_MATRIX, proj );  /* Rcupere la matrice de projection */
   }

   float   t;

   /* On combine les 2, en multipliant la matrice de projection par celle de modelisation*/
   clip[ 0] = modl[ 0] * proj[ 0] + modl[ 1] * proj[ 4] + modl[ 2] * proj[ 8] + modl[ 3] * proj[12];
   clip[ 1] = modl[ 0] * proj[ 1] + modl[ 1] * proj[ 5] + modl[ 2] * proj[ 9] + modl[ 3] * proj[13];
   clip[ 2] = modl[ 0] * proj[ 2] + modl[ 1] * proj[ 6] + modl[ 2] * proj[10] + modl[ 3] * proj[14];
   clip[ 3] = modl[ 0] * proj[ 3] + modl[ 1] * proj[ 7] + modl[ 2] * proj[11] + modl[ 3] * proj[15];

   clip[ 4] = modl[ 4] * proj[ 0] + modl[ 5] * proj[ 4] + modl[ 6] * proj[ 8] + modl[ 7] * proj[12];
   clip[ 5] = modl[ 4] * proj[ 1] + modl[ 5] * proj[ 5] + modl[ 6] * proj[ 9] + modl[ 7] * proj[13];
   clip[ 6] = modl[ 4] * proj[ 2] + modl[ 5] * proj[ 6] + modl[ 6] * proj[10] + modl[ 7] * proj[14];
   clip[ 7] = modl[ 4] * proj[ 3] + modl[ 5] * proj[ 7] + modl[ 6] * proj[11] + modl[ 7] * proj[15];

   clip[ 8] = modl[ 8] * proj[ 0] + modl[ 9] * proj[ 4] + modl[10] * proj[ 8] + modl[11] * proj[12];
   clip[ 9] = modl[ 8] * proj[ 1] + modl[ 9] * proj[ 5] + modl[10] * proj[ 9] + modl[11] * proj[13];
   clip[10] = modl[ 8] * proj[ 2] + modl[ 9] * proj[ 6] + modl[10] * proj[10] + modl[11] * proj[14];
   clip[11] = modl[ 8] * proj[ 3] + modl[ 9] * proj[ 7] + modl[10] * proj[11] + modl[11] * proj[15];

   clip[12] = modl[12] * proj[ 0] + modl[13] * proj[ 4] + modl[14] * proj[ 8] + modl[15] * proj[12];
   clip[13] = modl[12] * proj[ 1] + modl[13] * proj[ 5] + modl[14] * proj[ 9] + modl[15] * proj[13];
   clip[14] = modl[12] * proj[ 2] + modl[13] * proj[ 6] + modl[14] * proj[10] + modl[15] * proj[14];
   clip[15] = modl[12] * proj[ 3] + modl[13] * proj[ 7] + modl[14] * proj[11] + modl[15] * proj[15];

   /* Extrait le plan de DROITE */
   frustum[0][0] = clip[ 3] - clip[ 0];
   frustum[0][1] = clip[ 7] - clip[ 4];
   frustum[0][2] = clip[11] - clip[ 8];
   frustum[0][3] = clip[15] - clip[12];

   /* Calcul des normales */
   t = sqrt( frustum[0][0] * frustum[0][0] + frustum[0][1] * frustum[0][1] + frustum[0][2] * frustum[0][2] );
   frustum[0][0] /= t;
   frustum[0][1] /= t;
   frustum[0][2] /= t;
   frustum[0][3] /= t;

   /* Extrait le plan de GAUCHE */
   frustum[1][0] = clip[ 3] + clip[ 0];
   frustum[1][1] = clip[ 7] + clip[ 4];
   frustum[1][2] = clip[11] + clip[ 8];
   frustum[1][3] = clip[15] + clip[12];

   /* Calcul des normales */
   t = sqrt( frustum[1][0] * frustum[1][0] + frustum[1][1] * frustum[1][1] + frustum[1][2] * frustum[1][2] );
   frustum[1][0] /= t;
   frustum[1][1] /= t;
   frustum[1][2] /= t;
   frustum[1][3] /= t;

   /* Extrait le plan du BAS */
   frustum[2][0] = clip[ 3] + clip[ 1];
   frustum[2][1] = clip[ 7] + clip[ 5];
   frustum[2][2] = clip[11] + clip[ 9];
   frustum[2][3] = clip[15] + clip[13];

   /* Calcul des normales */
   t = sqrt( frustum[2][0] * frustum[2][0] + frustum[2][1] * frustum[2][1] + frustum[2][2] * frustum[2][2] );
   frustum[2][0] /= t;
   frustum[2][1] /= t;
   frustum[2][2] /= t;
   frustum[2][3] /= t;

   /* Extrait le plan du HAUT */
   frustum[3][0] = clip[ 3] - clip[ 1];
   frustum[3][1] = clip[ 7] - clip[ 5];
   frustum[3][2] = clip[11] - clip[ 9];
   frustum[3][3] = clip[15] - clip[13];

   /* Calcul des normales */
   t = sqrt( frustum[3][0] * frustum[3][0] + frustum[3][1] * frustum[3][1] + frustum[3][2] * frustum[3][2] );
   frustum[3][0] /= t;
   frustum[3][1] /= t;
   frustum[3][2] /= t;
   frustum[3][3] /= t;

   /* Extrait le plan ELOIGNE */
   frustum[4][0] = clip[ 3] - clip[ 2];
   frustum[4][1] = clip[ 7] - clip[ 6];
   frustum[4][2] = clip[11] - clip[10];
   frustum[4][3] = clip[15] - clip[14];

   /* Calcul des normales */
   t = sqrt( frustum[4][0] * frustum[4][0] + frustum[4][1] * frustum[4][1] + frustum[4][2] * frustum[4][2] );
   frustum[4][0] /= t;
   frustum[4][1] /= t;
   frustum[4][2] /= t;
   frustum[4][3] /= t;

   /* Extrait le plan PROCHE */
   frustum[5][0] = clip[ 3] + clip[ 2];
   frustum[5][1] = clip[ 7] + clip[ 6];
   frustum[5][2] = clip[11] + clip[10];
   frustum[5][3] = clip[15] + clip[14];

   /* Calcul des normales */
   t = sqrt( frustum[5][0] * frustum[5][0] + frustum[5][1] * frustum[5][1] + frustum[5][2] * frustum[5][2] );
   frustum[5][0] /= t;
   frustum[5][1] /= t;
   frustum[5][2] /= t;
   frustum[5][3] /= t;
	
}

int Frustum :: PointInFrustum( float x, float y, float z )
{
   int p;

   for( p = 0; p < 6; p++ )	// pour tous les plans
	   // si le point est en dehors d un des plans
      if( frustum[p][0] * x + frustum[p][1] * y + frustum[p][2] * z + frustum[p][3] <= 0 )
         return dehors;	// on se barre
   return dedans;	// sinon c ok
}

int Frustum :: SphereInFrustum( float x, float y, float z, float radius )
{
   int p;
   int c = 0;	/* le nombre de fois qu on est dans le frustum : 
   si on y est 6 fois, on est completement
   si on y est 0 fois, on est en dehors
   sinon, on est partiellement dedans */
   float d;

   for( p = 0; p < 6; p++ )	// pour tous les plans
   {
      d = frustum[p][0] * x + frustum[p][1] * y + frustum[p][2] * z + frustum[p][3];
      if( d <= -radius )	// si on est en dehors d un des plans
         return dehors;		// on est en dehors
      if( d > radius )		// sinon on incremente le nombre de fois qu on est dans le plan
         c++;
   }
   return (c == 6) ? dedans : part_dedans; // voir plus haut pour comprendre ce test
}

int Frustum :: CubeInFrustum( float x, float y, float z, float size )
{
	int p;

	for( p = 0; p < 6; p++ )
	{
		if( frustum[p][0] * (x - size) + frustum[p][1] * (y - size) + frustum[p][2] * (z - size) + frustum[p][3] > 0 )
			continue;
		if( frustum[p][0] * (x + size) + frustum[p][1] * (y - size) + frustum[p][2] * (z - size) + frustum[p][3] > 0 )
			continue;
		if( frustum[p][0] * (x - size) + frustum[p][1] * (y + size) + frustum[p][2] * (z - size) + frustum[p][3] > 0 )
			continue;
		if( frustum[p][0] * (x + size) + frustum[p][1] * (y + size) + frustum[p][2] * (z - size) + frustum[p][3] > 0 )
			continue;
		if( frustum[p][0] * (x - size) + frustum[p][1] * (y - size) + frustum[p][2] * (z + size) + frustum[p][3] > 0 )
			continue;
		if( frustum[p][0] * (x + size) + frustum[p][1] * (y - size) + frustum[p][2] * (z + size) + frustum[p][3] > 0 )
			continue;
		if( frustum[p][0] * (x - size) + frustum[p][1] * (y + size) + frustum[p][2] * (z + size) + frustum[p][3] > 0 )
			continue;
		if( frustum[p][0] * (x + size) + frustum[p][1] * (y + size) + frustum[p][2] * (z + size) + frustum[p][3] > 0 )
			continue;
		return dehors;
	}
	return dedans;
}

bool Frustum :: SameMatrix( )
{
	static int i = 0;
	glGetFloatv( GL_MODELVIEW_MATRIX, modl );   /* Rcupere la matrice de modelisation */
	for (i=0; i < 16; i++)	// Pour les 2 matrices
	{
	if ( modl[i] == old_ModelView[i] ) // si cet element de la matrice est egal a celui de la derniere sauvegarde, 
		continue;	// on passe a l element suivant...
	else
	{
		for (i =0; i > 16; i++)
			old_ModelView[i] = modl[i];	
		change = true;
		return 0;	// sinon, on retourne 0, parce que la matrice a t modifi ...
	}	
	}
	
	glGetFloatv( GL_PROJECTION_MATRIX, proj );  /* Rcupere la matrice de projection */
	for (i=0; i < 16; i++)	// Pour les 2 matrices
	{
	if ( proj[i] == old_Projection[i] ) // si cet element de la matrice est egal a celui de la derniere sauvegarde, 
		continue;	// on passe a l element suivant...
	else
	{
		for (i =0; i > 16; i++)
			old_Projection[i] = proj[i];
		change = true;
		return 0;	// sinon, on retourne 0, parce que la matrice a t modifi ...
	}
	}

change = false;
return 1;	// et si les 2 matrices sont egales, alors c est que la matrice na pas chang ... 
//donc il ne reste plus qu' a tester si les elements sont visible ... et la c a vous ....
}

void Frustum :: SetChanged (bool b_change)
{
	change = b_change;
}


void Frustum ::SetPortal(float cameraX,float cameraY,float cameraZ,float x1,float y1,float z1,float x2,float y2,float z2,float x3,float y3,float z3,float x4,float y4,float z4)
{
	float camera[3];
	camera[0]=cameraX;
	camera[1]=cameraY;
	camera[2]=cameraZ;

	float portal[4][3];
	portal[0][0]=x1;
	portal[0][1]=y1;
	portal[0][2]=z1;

	portal[1][0]=x2;
	portal[1][1]=y2;
	portal[1][2]=z2;

	portal[2][0]=x3;
	portal[2][1]=y3;
	portal[2][2]=z3;

	portal[3][0]=x4;
	portal[3][1]=y4;
	portal[3][2]=z4;

	setPortalv(camera,portal);

}

void Frustum ::setPortalv(float camera[3],float portal[4][3])
{
	float vect1[3];
	float vect2[3];
	float normal[3];
	float norm;
	float d;

	// on calcule le vecteur reliant la camera et le point 0
	vect1[0]=camera[0]-portal[0][0];
	vect1[1]=camera[1]-portal[0][1];
	vect1[2]=camera[2]-portal[0][2];

	// on calcule le vecteur reliant la camera et le point 1
	vect2[0]=camera[0]-portal[1][0];
	vect2[1]=camera[1]-portal[1][1];
	vect2[2]=camera[2]-portal[1][2];

	// on calcule la normal au 2 vecteur precedents
	normal[0]=vect1[1]*vect2[2]-vect1[2]*vect2[1];
	normal[1]=vect1[2]*vect2[0]-vect1[0]*vect2[2];
	normal[2]=vect1[0]*vect2[1]-vect1[1]*vect2[0];

	// on calcule la norme du vecteur normal
	norm=sqrt(pow(normal[0],2)+pow(normal[1],2)+pow(normal[2],2));
	// et on normalize la normal
	normal[0]/=-norm;
	normal[1]/=-norm;
	normal[2]/=-norm;

	// on calcule la distance planaire (ax+by+cz+d=0)
	d=-(portal[0][0]*normal[0]+portal[0][1]*normal[1]+portal[0][2]*normal[2]);

	// et on met le tout dans le frustum de gauche
	frustum[1][0]=normal[0];
	frustum[1][1]=normal[1];
	frustum[1][2]=normal[2];
	frustum[1][3]=d;

	/////////////////////////////////////////////////////////////////////
	/////////////////////////////////////////////////////////////////////
	// on calcule le vecteur reliant la camera et le point 1
	vect1[0]=camera[0]-portal[1][0];
	vect1[1]=camera[1]-portal[1][1];
	vect1[2]=camera[2]-portal[1][2];

	// on calcule le vecteur reliant la camera et le point 2
	vect2[0]=camera[0]-portal[2][0];
	vect2[1]=camera[1]-portal[2][1];
	vect2[2]=camera[2]-portal[2][2];

	// on calcule la normal au 2 vecteur precedents
	normal[0]=vect1[1]*vect2[2]-vect1[2]*vect2[1];
	normal[1]=vect1[2]*vect2[0]-vect1[0]*vect2[2];
	normal[2]=vect1[0]*vect2[1]-vect1[1]*vect2[0];

	// on calcule la norme du vecteur normal
	norm=sqrt(pow(normal[0],2)+pow(normal[1],2)+pow(normal[2],2));
	// et on normalize la normal
	normal[0]/=-norm;
	normal[1]/=-norm;
	normal[2]/=-norm;

	// on calcule la distance planaire (ax+by+cz+d=0)
	d=-(portal[1][0]*normal[0]+portal[1][1]*normal[1]+portal[1][2]*normal[2]);

	// et on met le tout dans le frustum bas
	frustum[2][0]=normal[0];
	frustum[2][1]=normal[1];
	frustum[2][2]=normal[2];
	frustum[2][3]=d;

	/////////////////////////////////////////////////////////////////////
	/////////////////////////////////////////////////////////////////////
	// on calcule le vecteur reliant la camera et le point 2
	vect1[0]=camera[0]-portal[2][0];
	vect1[1]=camera[1]-portal[2][1];
	vect1[2]=camera[2]-portal[2][2];

	// on calcule le vecteur reliant la camera et le point 3
	vect2[0]=camera[0]-portal[3][0];
	vect2[1]=camera[1]-portal[3][1];
	vect2[2]=camera[2]-portal[3][2];

	// on calcule la normal au 2 vecteur precedents
	normal[0]=vect1[1]*vect2[2]-vect1[2]*vect2[1];
	normal[1]=vect1[2]*vect2[0]-vect1[0]*vect2[2];
	normal[2]=vect1[0]*vect2[1]-vect1[1]*vect2[0];

	// on calcule la norme du vecteur normal
	norm=sqrt(pow(normal[0],2)+pow(normal[1],2)+pow(normal[2],2));
	// et on normalize la normal
	normal[0]/=-norm;
	normal[1]/=-norm;
	normal[2]/=-norm;

	// on calcule la distance planaire (ax+by+cz+d=0)
	d=-(portal[2][0]*normal[0]+portal[2][1]*normal[1]+portal[2][2]*normal[2]);

	// et on met le tout dans le frustum de droite
	frustum[0][0]=normal[0];
	frustum[0][1]=normal[1];
	frustum[0][2]=normal[2];
	frustum[0][3]=d;

	/////////////////////////////////////////////////////////////////////
	/////////////////////////////////////////////////////////////////////
	// on calcule le vecteur reliant la camera et le point 2
	vect1[0]=camera[0]-portal[3][0];
	vect1[1]=camera[1]-portal[3][1];
	vect1[2]=camera[2]-portal[3][2];

	// on calcule le vecteur reliant la camera et le point 3
	vect2[0]=camera[0]-portal[0][0];
	vect2[1]=camera[1]-portal[0][1];
	vect2[2]=camera[2]-portal[0][2];

	// on calcule la normal au 2 vecteur precedents
	normal[0]=vect1[1]*vect2[2]-vect1[2]*vect2[1];
	normal[1]=vect1[2]*vect2[0]-vect1[0]*vect2[2];
	normal[2]=vect1[0]*vect2[1]-vect1[1]*vect2[0];

	// on calcule la norme du vecteur normal
	norm=sqrt(pow(normal[0],2)+pow(normal[1],2)+pow(normal[2],2));
	// et on normalize la normal
	normal[0]/=-norm;
	normal[1]/=-norm;
	normal[2]/=-norm;

	// on calcule la distance planaire (ax+by+cz+d=0)
	d=-(portal[3][0]*normal[0]+portal[3][1]*normal[1]+portal[3][2]*normal[2]);

	// et on met le tout dans le frustum du haut
	frustum[3][0]=normal[0];
	frustum[3][1]=normal[1];
	frustum[3][2]=normal[2];
	frustum[3][3]=d;

}

int Frustum ::RectInFrustum( float x1,float y1,float z1,float x2,float y2,float z2,float x3,float y3,float z3,float x4,float y4,float z4)
{
	float rect[4][3];
	rect[0][0]=x1;
	rect[0][1]=y1;
	rect[0][2]=z1;

	rect[1][0]=x2;
	rect[1][1]=y2;
	rect[1][2]=z2;

	rect[2][0]=x3;
	rect[2][1]=y3;
	rect[2][2]=z3;

	rect[3][0]=x4;
	rect[3][1]=y4;
	rect[3][2]=z4;

	
	return RectInFrustumv(rect);
}


// on test si on voit 
int Frustum ::RectInFrustumv(float rect[4][3])
{
	int p;

	for( p = 0; p < 6; p++ )
	{
		if( frustum[p][0] * rect[0][0] + frustum[p][1] * rect[0][1] + frustum[p][2] * rect[0][2] + frustum[p][3] > 0 )
			continue;
		if( frustum[p][0] * rect[1][0] + frustum[p][1] * rect[1][1] + frustum[p][2] * rect[1][2] + frustum[p][3] > 0 )
			continue;
		if( frustum[p][0] * rect[2][0] + frustum[p][1] * rect[2][1] + frustum[p][2] * rect[2][2] + frustum[p][3] > 0 )
			continue;
		if( frustum[p][0] * rect[3][0] + frustum[p][1] * rect[3][1] + frustum[p][2] * rect[3][2] + frustum[p][3] > 0 )
			continue;
		return dehors;
	}
	return dedans;

}





bool Frustum::ObjetInFrustum(Objet *obj)
{
	int p;
	float x = obj->getModel()->getBoundingBox()->getCentre().getCoord(0) + obj->getPosition().getCoord(0);
	float y = obj->getModel()->getBoundingBox()->getCentre().getCoord(1) + obj->getPosition().getCoord(1);
	float z = obj->getModel()->getBoundingBox()->getCentre().getCoord(2) + obj->getPosition().getCoord(2);
	float larg = obj->getModel()->getBoundingBox()->getLargeur();
	float haut = obj->getModel()->getBoundingBox()->getHauteur();
	float prof = obj->getModel()->getBoundingBox()->getProfondeur();

	for( p = 0; p < 6; p++ )
	{
		if( frustum[p][0] * (x - larg) + frustum[p][1] * (y - haut) + frustum[p][2] * (z - prof) + frustum[p][3] > 0 )
			continue;
		if( frustum[p][0] * (x + larg) + frustum[p][1] * (y - haut) + frustum[p][2] * (z - prof) + frustum[p][3] > 0 )
			continue;
		if( frustum[p][0] * (x - larg) + frustum[p][1] * (y + haut) + frustum[p][2] * (z - prof) + frustum[p][3] > 0 )
			continue;
		if( frustum[p][0] * (x + larg) + frustum[p][1] * (y + haut) + frustum[p][2] * (z - prof) + frustum[p][3] > 0 )
			continue;
		if( frustum[p][0] * (x - larg) + frustum[p][1] * (y - haut) + frustum[p][2] * (z + prof) + frustum[p][3] > 0 )
			continue;
		if( frustum[p][0] * (x + larg) + frustum[p][1] * (y - haut) + frustum[p][2] * (z + prof) + frustum[p][3] > 0 )
			continue;
		if( frustum[p][0] * (x - larg) + frustum[p][1] * (y + haut) + frustum[p][2] * (z + prof) + frustum[p][3] > 0 )
			continue;
		if( frustum[p][0] * (x + larg) + frustum[p][1] * (y + haut) + frustum[p][2] * (z + prof) + frustum[p][3] > 0 )
			continue;
		return dehors;
	}
	return dedans;

}
