// GameMenu.cpp: implementation of the GameMenu class.
//
//////////////////////////////////////////////////////////////////////

#include "GameMenu.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

GameMenu::GameMenu()
{
	this->image = new RULES_Texture();
	image->loadBMP("./ressources/textures/fond_menu.bmp",true,GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_REPEAT,GL_REPEAT,0,false,192,192,192,0,1);

	float mouseValue = 0;

	retour = new Bouton();
	RULES_Texture * retour1 = new RULES_Texture();
	RULES_Texture * retour2 = new RULES_Texture();
	retour1->loadBMP("./ressources/textures/ihm/retour1.bmp",true,GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP,GL_CLAMP,0,true,0,0,0,0,1);
	retour2->loadBMP("./ressources/textures/ihm/retour2.bmp",true,GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP,GL_CLAMP,0,true,0,0,0,0,1);
	retour->setImageNormal(retour2);
	retour->setImagePassed(retour1);
	retour->setHeight(32);
	retour->setWidth(64);
	retour->setPosition(100,650);

	difficultyUp	= new Bouton();
	difficultyDown	= new Bouton();
	mouseUp			= new Bouton();
	mouseDown		= new Bouton();

	RULES_Texture * diffUp1 = new RULES_Texture();
	RULES_Texture * diffUp2 = new RULES_Texture();

	RULES_Texture * diffDown1 = new RULES_Texture();
	RULES_Texture * diffDown2 = new RULES_Texture();

	RULES_Texture * mouseUp1 = new RULES_Texture();
	RULES_Texture * mouseUp2 = new RULES_Texture();

	RULES_Texture * mouseDown1 = new RULES_Texture();
	RULES_Texture * mouseDown2 = new RULES_Texture();

	diffUp1		->loadBMP("./ressources/textures/ihm/fleched.bmp",true,GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP,GL_CLAMP,0,true,0,0,0,0,1);
	diffUp2		->loadBMP("./ressources/textures/ihm/fleched.bmp",true,GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP,GL_CLAMP,0,true,0,0,0,0,1);
	diffDown1	->loadBMP("./ressources/textures/ihm/flecheg.bmp",true,GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP,GL_CLAMP,0,true,0,0,0,0,1);
	diffDown2	->loadBMP("./ressources/textures/ihm/flecheg.bmp",true,GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP,GL_CLAMP,0,true,0,0,0,0,1);
	mouseUp1	->loadBMP("./ressources/textures/ihm/fleched.bmp",true,GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP,GL_CLAMP,0,true,0,0,0,0,1);
	mouseUp2	->loadBMP("./ressources/textures/ihm/fleched.bmp",true,GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP,GL_CLAMP,0,true,0,0,0,0,1);
	mouseDown1	->loadBMP("./ressources/textures/ihm/flecheg.bmp",true,GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP,GL_CLAMP,0,true,0,0,0,0,1);
	mouseDown2	->loadBMP("./ressources/textures/ihm/flecheg.bmp",true,GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP,GL_CLAMP,0,true,0,0,0,0,1);

	difficultyUp	->setImageNormal(diffUp1);
	difficultyUp	->setImagePassed(diffUp2);
	difficultyDown	->setImageNormal(diffDown1);
	difficultyDown	->setImagePassed(diffDown2);
	mouseUp			->setImageNormal(mouseUp1);
	mouseUp			->setImagePassed(mouseUp2);
	mouseDown		->setImageNormal(mouseDown1);
	mouseDown		->setImagePassed(mouseDown2);

	difficultyUp	->setPosition(355,200);
	difficultyDown	->setPosition(200,200);

	difficultyUp	->setHeight(16);
	difficultyUp	->setWidth(16);

	difficultyDown	->setHeight(16);
	difficultyDown	->setWidth(16);

	mouseUp			->setPosition(605,300);
	mouseDown		->setPosition(400,300);

	mouseUp			->setHeight(16);
	mouseUp			->setWidth(16);

	mouseDown		->setHeight(16);
	mouseDown		->setWidth(16);
}

GameMenu::~GameMenu()
{
	if (image != NULL)
	{
		delete this->image ;
		image = NULL;
	}
	if (retour != NULL)
	{
		delete retour;
		retour = NULL;
	}
	if (difficultyUp != NULL)
	{
		delete difficultyUp;
		difficultyUp = NULL;
	}
	if (difficultyDown != NULL)
	{
		delete difficultyDown;
		difficultyDown = NULL;
	}
	if (mouseUp != NULL)
	{
		delete mouseUp;
		mouseUp = NULL;
	}
	if (mouseDown != NULL)
	{
		delete mouseDown;
		mouseDown = NULL;
	}

}

void GameMenu::draw(void)
{
	glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
	glLoadIdentity();
	gluLookAt(0,100,100,0,0,0,0,1,0);
	// affiche un rectangle de test
	// on desactive le depth test
	glDisable(GL_DEPTH_TEST);
	// on passe en mode projection
	glMatrixMode(GL_PROJECTION);
		
				// on sauvegarde la matrice de projection
	glPushMatrix();
	
		// on nettoie la matrice de projection
		glLoadIdentity();
		
		// on passe en mode ortho de la taille de l'ecran
		glOrtho(0,1024,0,768,-1,1);	
		
		// on passe en mode modelview
		glMatrixMode(GL_MODELVIEW);
		
		// on sauvegarde la matrice de modelview
		glPushMatrix();
		
			// on nettoie la matrice de projection
			glLoadIdentity();
			
			glEnable(GL_TEXTURE_2D);
			glBindTexture(GL_TEXTURE_2D, this->image->getId());
			glBegin(GL_QUADS);
				glTexCoord2f(0,0);
				glVertex3f(0,0,0);
				glTexCoord2f(1,0);
				glVertex3f(1024,0,0);
				glTexCoord2f(1,1);
				glVertex3f(1024,768,0);
				glTexCoord2f(0,1);
				glVertex3f(0,768,0);
			glEnd();

			glMatrixMode(GL_PROJECTION);
		
		// et on recupere la matrice de projection sauvegard precedement
		glPopMatrix();	
		
		// on selectionne la matrice de projection modelview
		glMatrixMode(GL_MODELVIEW);
	glPopMatrix();
	// on desactive le depth test
	glEnable(GL_DEPTH_TEST);

	//glEnable(GL_ALPHA_TEST);
	glAlphaFunc(GL_GREATER,0);

	difficultyUp	->draw(mouseX,mouseY);
	difficultyDown	->draw(mouseX,mouseY);
	retour			->draw(mouseX,mouseY);
	mouseUp			->draw(mouseX,mouseY);
	mouseDown		->draw(mouseX,mouseY);
	
	//glDisable(GL_ALPHA_TEST);

	Font * font = MainMenu::getInstance()->getFont();
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA,GL_SRC_ALPHA);
	font->glText2d(400*0.78,100*0.78,"Options du jeu");
	font->glText2d(50*0.78,200*0.78,"Difficulte");
	switch (Game::getGame()->getDifficulty())
	{
		case 5:
			font->glText2d(220*0.78,200*0.78,"  Facile");
			break;
		case 10:
			font->glText2d(220*0.78,200*0.78,"  Normal");
			break;
		case 15:
			font->glText2d(220*0.78,200*0.78,"Difficile");
			break;
		case 20:
			font->glText2d(220*0.78,200*0.78,"Impossible");
			break;

	}
	if (Game::getGame()->isPaused())
	{
		font->glText2d(150*0.78,230*0.78,"Attention, changer la difficulte relancera la partie en cours");
	}
	font->glText2d(50*0.78,300*0.78,"Sensibilitee de la souris");
	font->glText2d(475*0.78 + 10 * mouseValue,300*0.78,"X");

	RULES_Vector pos;
	pos.setCoord(mouseX,768-mouseY,0);
	ParticleEngine::getInstance()->frame(&pos);
	Mouse::getInstance()->draw(&pos);

	glFlush();
	glutSwapBuffers();
	// on lui fait charger la partie

}


void GameMenu::idle(void)
{
	// on charge le sound manager et on verifie le son
	SoundManager::getInstance()->checkSound();
	glutPostRedisplay();

}


void GameMenu::mouseClicked(int boutton,int etat,int x,int y)
{
	if (etat == GLUT_DOWN)
	{
		SoundManager::getInstance()->playClic();
		if (retour->isIn(x,y))
		{
			GLUT * main = OptionMenu::getInstance();
			*(this->currentGlut) = main; 
			main->setCurrentGlut(this->currentGlut);
		}
		if (difficultyUp->isIn(x,y))
		{
			int diff = Game::getGame()->getDifficulty();
			if (diff + 5 <=20)
			{
				diff+=5;
			}
			Game::getGame()->setDifficulty(diff);
			Game::getGame()->setPaused(false);
		}
		if (difficultyDown->isIn(x,y))
		{
			int diff = Game::getGame()->getDifficulty();
			if (diff - 5 >= 5)
			{
				diff-=5;
			}
			Game::getGame()->setDifficulty(diff);
			Game::getGame()->setPaused(false);
		}
		if (mouseDown->isIn(x,y))
		{
			if (mouseValue >=-4)
			{
				mouseValue --;
				Game::getGame()->getPlayer()->setMouseSensibilityX(0.0018+mouseValue*0.0003);
				Game::getGame()->getPlayer()->setMouseSensibilityY(0.0012+mouseValue*0.0002);
			}
		}
		if (mouseUp->isIn(x,y))
		{
			if (mouseValue <=8)
			{
				mouseValue ++;
				Game::getGame()->getPlayer()->setMouseSensibilityX(0.0018+mouseValue*0.0003);
				Game::getGame()->getPlayer()->setMouseSensibilityY(0.0012+mouseValue*0.0002);
			}
		}
	}
}

void GameMenu::mouseMoved(int x,int y)
{
	mouseX = x;
	mouseY = y;
}

void GameMenu::mouseMovedClicked(int x,int y)
{

}


void GameMenu::keyPressed(unsigned char key,int x,int y)
{
}

void GameMenu::keyReleased(unsigned char key,int x,int y)
{
	if (key == 27)
	{
		GLUT * main = OptionMenu::getInstance();
		*(this->currentGlut) = main; 
		main->setCurrentGlut(this->currentGlut);
	}

}


void GameMenu::reshape(int largeur,int hauteur)
{
	glViewport(0,0,(GLsizei) largeur,(GLsizei) hauteur);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(90,largeur/hauteur,1,10000);
	glMatrixMode(GL_MODELVIEW);

}

