// GameMenu.h: interface for the GameMenu class.
//
//////////////////////////////////////////////////////////////////////

#ifndef GAMEMENU_H
#define GAMEMENU_H

#include "Menu.h"
#include "OptionMenu.h"
#include "Game.h"
#include "ParticleEngine.h"
#include "Mouse.h"
#include "Bouton.h"

/**
 * classe gerant le menu des parametres de jeu.
 *
 * pour plus de renseignement sur les methode de cette classe, voir la classe GLUT
 */
class GameMenu : public Menu  
{
	int mouseX,mouseY;
	Bouton * difficultyUp;
	Bouton * difficultyDown;
	Bouton * mouseUp;
	Bouton * mouseDown;
	float mouseValue;
	Bouton * retour;

	GameMenu();
public:
	virtual ~GameMenu();
	static GameMenu * getInstance(){static GameMenu instance; return &instance;};

	void draw(void);

	void idle(void);

	void mouseClicked(int boutton,int etat,int x,int y);
	void mouseMoved(int x,int y);
	void mouseMovedClicked(int x,int y);

	void keyPressed(unsigned char key,int x,int y);
	void keyReleased(unsigned char key,int x,int y);
	void specialKeyFunc(int key,int x,int y){};
	void specialKeyUpFunc(int key,int x,int y){};

	void reshape(int largeur,int hauteur);
};

#endif
