// MainMenu.cpp: implementation of the MainMenu class.
//
//////////////////////////////////////////////////////////////////////

#include "MainMenu.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

MainMenu::MainMenu()
{
	font = new Font();
	texFont = new RULES_Texture();
	texFont->loadBMP("./ressources/textures/Font.bmp",true,GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_REPEAT,GL_REPEAT,0,false,192,192,192,0,1);
	font->setTextureProperties(texFont->getId(),15,15);
	font->setBaseCaractere(32);
	font->setCaractereSize(15,15,10);
	// on met une fausse taille d'ecran pour avoir de text plus gros
	font->setScreenSize(800,600);
	font->buildFont();

	this->infoDefile = 300;

	this->image = new RULES_Texture();
	image->loadBMP("./ressources/textures/fond_menu.bmp",true,GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_REPEAT,GL_REPEAT,0,false,192,192,192,0,1);

	loutre = new Loutre[2];
	RULES_Vector center;
	center.setCoord(0,0,0);
	RULES_Vector  destination ;
	destination.setCoord(0,0,200);
	loutre[0].initialise(center,0);
	loutre[0].setDestination(destination);
	loutre[0].setIncrAngle(5);
	loutre[0].setCurrentAngle(0);
	loutre[0].setMaxAngle(5);
	loutre[0].setModelDrawer(Game::getGame()->getDrawer());
	loutre[0].setModel(Game::getGame()->getLoutreModel());

	RULES_Vector pos;
	pos.setCoord(220,0,-80);
	loutre[1].initialise(pos,0);
	loutre[1].calcFactor();
	loutre[1].setPosition(pos);
	RULES_Vector destination2;
	destination2.setCoord(-220,0,-80);
	loutre[1].setDestination(destination2);
	loutre[1].setIncrAngle(10);
	loutre[1].setCurrentAngle(0);
	loutre[1].setMaxAngle(5);
	loutre[1].setModelDrawer(Game::getGame()->getDrawer());
	loutre[1].setModel(Game::getGame()->getLoutreModel());
	loutre[1].setSpeed(0.02);
	loutre[1].setVie(10);
	
	loutre[0].calcFactor();

	titre = new Model();
	titre->load("./ressources/models/PDL.obj");
	RULES_Texture * texPDL = new RULES_Texture();
	texPDL->loadBMP("./ressources/textures/PDL.bmp",true,GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP,GL_CLAMP,0,false,0,0,255,0,1);
	titre->setTexture(texPDL);

	boutons = new Bouton();
	boutons->setLeft(448);
	boutons->setTop(200);
	boutons->setHeight(64);
	boutons->setWidth(128);
	RULES_Texture * image1 = new RULES_Texture();
	RULES_Texture * image2 = new RULES_Texture();
	image1->loadBMP("./ressources/textures/ihm/bouton2.bmp",true,GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP,GL_CLAMP,0,true,0,0,0,0,1);
	image2->loadBMP("./ressources/textures/ihm/bouton1.bmp",true,GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP,GL_CLAMP,0,true,0,0,0,0,1);
	boutons->setImageNormal(image1);
	boutons->setImagePassed(image2);

	quitter = new Bouton();
	quitter->setHeight(64);
	quitter->setWidth(256);
	quitter->setPosition(384,600);
	RULES_Texture * quitter1 = new RULES_Texture();
	RULES_Texture * quitter2 = new RULES_Texture();
	quitter1->loadBMP("./ressources/textures/ihm/quitter2.bmp",true,GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP,GL_CLAMP,0,true,0,0,0,0,1);
	quitter2->loadBMP("./ressources/textures/ihm/quitter1.bmp",true,GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP,GL_CLAMP,0,true,0,0,0,0,1);
	quitter->setImageNormal(quitter1);
	quitter->setImagePassed(quitter2);
	
	options = new Bouton();
	options->setHeight(64);
	options->setWidth(256);
	options->setPosition(384,400);
	RULES_Texture * options1 = new RULES_Texture();
	RULES_Texture * options2 = new RULES_Texture();
	options1->loadBMP("./ressources/textures/ihm/options2.bmp",true,GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP,GL_CLAMP,0,true,0,0,0,0,1);
	options2->loadBMP("./ressources/textures/ihm/options1.bmp",true,GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP,GL_CLAMP,0,true,0,0,0,0,1);
	options->setImageNormal(options1);
	options->setImagePassed(options2);
	
	resume = new Bouton();
	resume->setHeight(64);
	resume->setWidth(256);
	resume->setPosition(384,130);
	RULES_Texture * resume1 = new RULES_Texture();
	RULES_Texture * resume2 = new RULES_Texture();
	resume1->loadBMP("./ressources/textures/ihm/resume2.bmp",true,GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP,GL_CLAMP,0,true,0,0,0,0,1);
	resume2->loadBMP("./ressources/textures/ihm/resume1.bmp",true,GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP,GL_CLAMP,0,true,0,0,0,0,1);
	resume->setImageNormal(resume1);
	resume->setImagePassed(resume2);

}

MainMenu::~MainMenu()
{
	if (font != NULL)
	{
		delete font;
		font = NULL;
	}
	if (texFont != NULL)
	{
		delete texFont;
		texFont = NULL;
	}
	if (loutre != NULL)
	{
		delete[] loutre;
		loutre = NULL;
	}
	if (boutons != NULL)
	{
		delete boutons;
		boutons = NULL;
	}
	if (titre != NULL)
	{
		delete titre;
		titre = NULL;
	}
	if (image != NULL)
	{
		delete this->image ;
		image = NULL;
	}
	if (quitter != NULL)
	{
		delete quitter ;
		quitter = NULL;
	}
	if (options != NULL)
	{
		delete options ;
		options = NULL;
	}
	if (resume != NULL)
	{
		delete resume ;
		resume = NULL;
	}

}

void MainMenu::draw(void)
{
	// obligatoire lorsque on change le model de loutre....
	loutre[0].setModel(Game::getGame()->getLoutreModel());
	loutre[1].setModel(Game::getGame()->getLoutreModel());
	// vecteur representant la position de la souris (et de la lumiere)
	RULES_Vector pos;
	pos.setCoord(mouseX,768-mouseY,100);

	glClearColor(0,0,0,0);
	glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
	glLoadIdentity();
	gluLookAt(0,0,100,0,0,0,0,1,0);
	glEnable(GL_TEXTURE_2D);
	// on desactive le depth test
	glDisable(GL_DEPTH_TEST);
	// on passe en mode projection
	glMatrixMode(GL_PROJECTION);
		
				// on sauvegarde la matrice de projection
	glPushMatrix();
	
		// on nettoie la matrice de projection
		glLoadIdentity();
		
		// on passe en mode ortho de la taille de l'ecran
		glOrtho(0,1024,0,768,-1,1);	
		
		// on passe en mode modelview
		glMatrixMode(GL_MODELVIEW);
		
		// on sauvegarde la matrice de modelview
		glPushMatrix();
		
			// on nettoie la matrice de projection
			glLoadIdentity();
			
			glEnable(GL_TEXTURE_2D);
			glBindTexture(GL_TEXTURE_2D, this->image->getId());
			glBegin(GL_QUADS);
				glTexCoord2f(0,0);
				glVertex3f(0,0,0);
				glTexCoord2f(1,0);
				glVertex3f(1024,0,0);
				glTexCoord2f(1,1);
				glVertex3f(1024,768,0);
				glTexCoord2f(0,1);
				glVertex3f(0,768,0);
			glEnd();

			glMatrixMode(GL_PROJECTION);
		
		// et on recupere la matrice de projection sauvegard precedement
		glPopMatrix();	
		
		// on selectionne la matrice de projection modelview
		glMatrixMode(GL_MODELVIEW);
	glPopMatrix();
	// on desactive le depth test
	glEnable(GL_DEPTH_TEST);


	glColor3f(1,1,1);
	RULES_Vector light;
	RULES_Vector center;
	light.setCoord(180 * ((mouseX - 512.f)/1024.f),180*(((768-mouseY) - 384.f)/768.f),100);

	glPushMatrix();
		glTranslatef(0,70,-5);
		glScalef(2,2,2);
		RULES_Vector lightTitre = light;
		lightTitre.setCoord(lightTitre.getX(),lightTitre.getY() - 70, lightTitre.getZ() + 5);
		glColor3f(1,1,1);
		Game::getGame()->getDrawer()->draw(titre,lightTitre);
	glPopMatrix();
	loutre[0].setLight(&light);
	loutre[0].calcFactor();
	loutre[0].move();
	center.setCoord(-88,-90,-10);
	loutre[0].setPosition(center);
	glColor3f(1,1,1);
	loutre[0].draw(false);
	center.setCoord(88,-90,-10);
	loutre[0].setPosition(center);
	glColor3f(1,1,1);
	loutre[0].draw(false);

	if (loutre[1].getPosition().getX()>218)
	{
		RULES_Vector newPos = loutre[1].getPosition();
		newPos.setOneCoord(0,218);
		loutre[1].setPosition(newPos);
		RULES_Vector destination2;
		destination2.setCoord(-220,0,-80);
		loutre[1].setDestination(destination2);
	}
	if (loutre[1].getPosition().getX()<-218)
	{
		RULES_Vector newPos = loutre[1].getPosition();
		newPos.setOneCoord(0,-218);
		loutre[1].setPosition(newPos);
		RULES_Vector destination2;
		destination2.setCoord(220,0,-80);
		loutre[1].setDestination(destination2);
	}
	loutre[1].setLight(&light);
	loutre[1].calcDirection();
	loutre[1].move();
	glColor3f(1,1,1);
	loutre[1].draw(false);

	glEnable(GL_BLEND);
	glBlendFunc(GL_ONE_MINUS_SRC_ALPHA,GL_SRC_ALPHA);
	glColor4f(1,1,1,0.75);
	//glEnable(GL_ALPHA_TEST);
	glAlphaFunc(GL_GREATER,0);
		boutons->draw(mouseX,mouseY);
		quitter->draw(mouseX,mouseY);
		options->draw(mouseX,mouseY);
		if (Game::getGame()->isPaused())
		{
			resume->draw(mouseX,mouseY);
		}
	//glDisable(GL_ALPHA_TEST);

	glBlendFunc(GL_SRC_ALPHA,GL_SRC_ALPHA);
	glColor4f(0.5,0.25,0.25,1);
	font->glText2d(0,0,"Poutrage de loutres 1.0");
	glColor4f(0.25,0.25,0.25,1);
	font->glText2d(this->infoDefile,580,"Poutrage de loutres : Auteurs : Michel de VERDELHAN, Sebastien HILLAIRE.");
	glDisable(GL_BLEND);
	
	ParticleEngine::getInstance()->frame(&pos);
	Mouse::getInstance()->draw(&pos);

	glFlush();
	glutSwapBuffers();

}


void MainMenu::idle(void)
{
	SoundManager::getInstance()->checkSound();
	this->infoDefile-=0.05;
	if (this->infoDefile < -730)
	{
		this->infoDefile = 803;
	}
	glutPostRedisplay();

}


void MainMenu::mouseClicked(int boutton,int etat,int x,int y)
{
	if (etat == GLUT_DOWN)
	{
		SoundManager::getInstance()->playClic();
		if (boutons->isIn(x,y))
		{
			GLUT * game = Game::getGame();
			//Game::getGame()->setDifficulty(5);
			Game::getGame()->startGame();
			*(this->currentGlut) = game; 
			game->setCurrentGlut(this->currentGlut);
		}
		if (options->isIn(x,y))
		{
			GLUT * option = OptionMenu::getInstance();
			*(this->currentGlut) = option; 
			option->setCurrentGlut(this->currentGlut);
		}
		if (Game::getGame()->isPaused())
		{
			if (resume->isIn(x,y))
			{
				GLUT * game = Game::getGame();
				*(this->currentGlut) = game; 
				game->setCurrentGlut(this->currentGlut);
				Game::getGame()->resetTime();
			}
		}
	}
	if (etat == 1)
	{
		if (quitter->isIn(x,y))
		{
			GLUT * fin = LastMenu::getInstance();
			*(this->currentGlut) = fin; 
		}
	}

}

void MainMenu::mouseMoved(int x,int y)
{
	mouseX = x;
	mouseY = y;

}

void MainMenu::mouseMovedClicked(int x,int y)
{
	mouseX = x;
	mouseY = y;

}


void MainMenu::keyPressed(unsigned char key,int x,int y)
{
	if (key == 27)
	{
		GLUT * fin = LastMenu::getInstance();
		*(this->currentGlut) = fin; 
	}
}

void MainMenu::keyReleased(unsigned char key,int x,int y)
{
}


void MainMenu::reshape(int largeur,int hauteur)
{
	glViewport(0,0,(GLsizei) largeur,(GLsizei) hauteur);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(90,largeur/hauteur,1,10000);
	glMatrixMode(GL_MODELVIEW);

}


Font * MainMenu::getFont()
{
	return this->font;
}
