// OptionMenu.cpp: implementation of the OptionMenu class.
//
//////////////////////////////////////////////////////////////////////

#include "OptionMenu.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

OptionMenu::OptionMenu()
{
	this->image = new RULES_Texture();
	image->loadBMP("./ressources/textures/fond_menu.bmp",true,GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_REPEAT,GL_REPEAT,0,false,192,192,192,0,1);

	retour	= new Bouton();
	video	= new Bouton();
	son		= new Bouton();
	jeu		= new Bouton();

	RULES_Texture * retourTex1	= new RULES_Texture();
	RULES_Texture * retourTex2	= new RULES_Texture();
	RULES_Texture * videoTex1	= new RULES_Texture();
	RULES_Texture * videoTex2	= new RULES_Texture();
	RULES_Texture * sonTex1		= new RULES_Texture();
	RULES_Texture * sonTex2		= new RULES_Texture();
	RULES_Texture * jeuTex1		= new RULES_Texture();
	RULES_Texture * jeuTex2		= new RULES_Texture();

	retourTex1	->loadBMP("./ressources/textures/ihm/retour1.bmp",true,GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP,GL_CLAMP,0,true,0,0,0,0,1);
	retourTex2	->loadBMP("./ressources/textures/ihm/retour2.bmp",true,GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP,GL_CLAMP,0,true,0,0,0,0,1);
	videoTex1	->loadBMP("./ressources/textures/ihm/optvid1.bmp",true,GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP,GL_CLAMP,0,true,0,0,0,0,1);
	videoTex2	->loadBMP("./ressources/textures/ihm/optvid2.bmp",true,GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP,GL_CLAMP,0,true,0,0,0,0,1);
	sonTex1		->loadBMP("./ressources/textures/ihm/optaud1.bmp",true,GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP,GL_CLAMP,0,true,0,0,0,0,1);
	sonTex2		->loadBMP("./ressources/textures/ihm/optaud2.bmp",true,GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP,GL_CLAMP,0,true,0,0,0,0,1);
	jeuTex1		->loadBMP("./ressources/textures/ihm/optjeu1.bmp",true,GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP,GL_CLAMP,0,true,0,0,0,0,1);
	jeuTex2		->loadBMP("./ressources/textures/ihm/optjeu2.bmp",true,GL_LINEAR_MIPMAP_LINEAR,GL_LINEAR,GL_CLAMP,GL_CLAMP,0,true,0,0,0,0,1);

	retour	->setImagePassed(retourTex1);
	video	->setImagePassed(videoTex1);
	son		->setImagePassed(sonTex1);
	jeu		->setImagePassed(jeuTex1);

	retour	->setImageNormal(retourTex2);
	video	->setImageNormal(videoTex2);
	son		->setImageNormal(sonTex2);
	jeu		->setImageNormal(jeuTex2);

	retour	->setPosition(100,650);
	video	->setPosition(256,150);
	son		->setPosition(256,350);
	jeu		->setPosition(256,550);

	retour	->setHeight(32);
	video	->setHeight(64);
	son		->setHeight(64);
	jeu		->setHeight(64);

	retour	->setWidth(64);
	video	->setWidth(512);
	son		->setWidth(512);
	jeu		->setWidth(512);

}

OptionMenu::~OptionMenu()
{
	if (image != NULL)
	{
		delete this->image ;
		image = NULL;
	}
	if (retour != NULL)
	{
		delete retour ;
		retour = NULL;
	}
	if (video != NULL)
	{
		delete video ;
		video = NULL;
	}
	if (son != NULL)
	{
		delete son ;
		son = NULL;
	}
	if (jeu != NULL)
	{
		delete jeu ;
		jeu = NULL;
	}
}

void OptionMenu::draw(void)
{
	glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT);
	glLoadIdentity();
	gluLookAt(0,100,100,0,0,0,0,1,0);

	glEnable(GL_TEXTURE_2D);
	// on desactive le depth test
	glDisable(GL_DEPTH_TEST);
	// on passe en mode projection
	glMatrixMode(GL_PROJECTION);
		
				// on sauvegarde la matrice de projection
	glPushMatrix();
	
		// on nettoie la matrice de projection
		glLoadIdentity();
		
		// on passe en mode ortho de la taille de l'ecran
		glOrtho(0,1024,0,768,-1,1);	
		
		// on passe en mode modelview
		glMatrixMode(GL_MODELVIEW);
		
		// on sauvegarde la matrice de modelview
		glPushMatrix();
		
			// on nettoie la matrice de projection
			glLoadIdentity();
			
			glEnable(GL_TEXTURE_2D);
			glBindTexture(GL_TEXTURE_2D, this->image->getId());
			glBegin(GL_QUADS);
				glTexCoord2f(0,0);
				glVertex3f(0,0,0);
				glTexCoord2f(1,0);
				glVertex3f(1024,0,0);
				glTexCoord2f(1,1);
				glVertex3f(1024,768,0);
				glTexCoord2f(0,1);
				glVertex3f(0,768,0);
			glEnd();

			glMatrixMode(GL_PROJECTION);
		
		// et on recupere la matrice de projection sauvegard precedement
		glPopMatrix();	
		
		// on selectionne la matrice de projection modelview
		glMatrixMode(GL_MODELVIEW);
	glPopMatrix();
	// on desactive le depth test
	glEnable(GL_DEPTH_TEST);
	
	//glEnable(GL_ALPHA_TEST);
	glAlphaFunc(GL_GREATER,0);
	// affichage des boutons
	retour	->draw(mouseX,mouseY);
	video	->draw(mouseX,mouseY);
	son		->draw(mouseX,mouseY);
	jeu		->draw(mouseX,mouseY);

	//glDisable(GL_ALPHA_TEST);

	Font * font = MainMenu::getInstance()->getFont();
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA,GL_SRC_ALPHA);
	// affichage du text
	glDisable(GL_BLEND);

	RULES_Vector pos;
	pos.setCoord(mouseX,768-mouseY,0);
	ParticleEngine::getInstance()->frame(&pos);
	Mouse::getInstance()->draw(&pos);

	glFlush();
	glutSwapBuffers();
}


void OptionMenu::idle(void)
{
	SoundManager::getInstance()->checkSound();
	glutPostRedisplay();

}


void OptionMenu::mouseClicked(int boutton,int etat,int x,int y)
{
	if (etat == GLUT_DOWN)
	{
		SoundManager::getInstance()->playClic();
		if (retour->isIn(x,y))
		{
			GLUT * main = MainMenu::getInstance();
			*(this->currentGlut) = main; 
			main->setCurrentGlut(this->currentGlut);
		}
		if (son->isIn(x,y))
		{
			GLUT * sons = SonsMenu::getInstance();
			*(this->currentGlut) = sons; 
			sons->setCurrentGlut(this->currentGlut);
		}
		if (jeu->isIn(x,y))
		{
			GLUT * jeu = GameMenu::getInstance();
			*(this->currentGlut) = jeu; 
			jeu->setCurrentGlut(this->currentGlut);
		}
		if (video->isIn(x,y))
		{
			GLUT * vid = VideoMenu::getInstance();
			*(this->currentGlut) = vid; 
			vid->setCurrentGlut(this->currentGlut);
		}
	}
}

void OptionMenu::mouseMoved(int x,int y)
{
	mouseX = x;
	mouseY = y;
}

void OptionMenu::mouseMovedClicked(int x,int y)
{

}


void OptionMenu::keyPressed(unsigned char key,int x,int y)
{
}

void OptionMenu::keyReleased(unsigned char key,int x,int y)
{
	if (key == 27)
	{
		GLUT * main = MainMenu::getInstance();
		*(this->currentGlut) = main; 
		main->setCurrentGlut(this->currentGlut);
	}

}


void OptionMenu::reshape(int largeur,int hauteur)
{
	glViewport(0,0,(GLsizei) largeur,(GLsizei) hauteur);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(90,largeur/hauteur,1,10000);
	glMatrixMode(GL_MODELVIEW);

}

